using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.IO;
using System.Windows.Forms;
using IC.PhotoController;
using IC.PhotoController.Border;
using IC.PhotoController.Filter;

namespace PhotoControllerDemo
{

    /// <summary>
    /// Summary description for Form2.
    /// </summary>
    public class frmMain : Form
    {
        #region Main form components
        private MenuItem menuItem1;
        private MenuItem menuItem3;
        private MenuItem menuItem5;
        private MenuItem menuItem10;
        private MainMenu mainMenu;
        private ToolBar toolBar;
        private ToolBarButton tbOpen;
        private ImageList imgList;
        private MenuItem menuItem13;
        private ToolBarButton tbSave;
        private ToolBarButton toolBarButton1;
        private ToolBarButton tbCrop;
        private ToolBarButton tbResize;
        private ToolBarButton tbRotate;
        private ToolBarButton tbFlip;
        private Panel palMain;
        public PictureBox pic;
        private OpenFileDialog dlgFile;
        private IContainer components;
        private MenuItem mnuOpen;
        private MenuItem mnuSave;
        private MenuItem mnuExit;
        private MenuItem mnuResize;
        private MenuItem mnuRotate;
        private MenuItem mnuFlip;
        private MenuItem mnuCrop;
        private MenuItem mnuAdjust;
        private MenuItem mnuAbout;
        private MenuItem mnuReset;
        private MenuItem menuItem4;
        private ToolBarButton tbReset;

        private SaveFileDialog dlgSave;
        private ToolBarButton tbColorAdjust;
        private ToolBarButton toolBarButton3;
        private ColorDialog dlgColor;
        private ToolBarButton toolBarButton4;
        private MenuItem mnuTransparent;
        private MenuItem menuItem2;
        private MenuItem mnuGray;
        private MenuItem mnuInvert;
        private MenuItem mnuContrast;
        private MenuItem mnuGamma;
        private MenuItem menuItem11;
        private MenuItem mnuSmooth;
        private MenuItem mnuBlur;
        private MenuItem mnuEmboss;
        private MenuItem mnuEngrave;
        private MenuItem mnuMosaic;
        private MenuItem mnuSettings;
        private MenuItem mnuBackgroundColor;
        private MenuItem mnuBlackWhite;
        private MenuItem mnuSepia;
        private MenuItem mnuMeanRemoval;
        private MenuItem mnuSharpen;
        private MenuItem mnuEDSobel;
        private MenuItem mnuEDPrewiit;
        private MenuItem mnuEDKirsh;
        private MenuItem EDFreiChen;
        private MenuItem mnuEDRoberts;
        private MenuItem mnuEDDifference;
        private MenuItem mnuBlurGroup;
        private MenuItem mnuSharpenGroup;
        private MenuItem mnuStylizeGroup;
        private MenuItem mnuDiffuse;
        private MenuItem mnuDistortGroup;
        private MenuItem mnuDither;
        private MenuItem mnuCanvas;
        private MenuItem mnuGlassBorder;
        private MenuItem mnuWater;
        private MenuItem mnuGrey;
        private MenuItem menuItem7;
        private MenuItem mnuSaveGif;
        private MenuItem menuItem8;
        private MenuItem mnuFeather;
        private MenuItem mnuSetBorder;
        private MenuItem mnuFeather1;
        private MenuItem mnuFeather3;
        private MenuItem mnuFeather2;
        private MenuItem menuScale;
        private MenuItem mnuEdgeDetection;
        private MenuItem mnuRender;
        private MenuItem mnuLightness;
        private MenuItem mnuDarkness;
        private MenuItem mnuNoise;
        private MenuItem mnuDeepBlur;
        private MenuItem mnuHSL;
        private MenuItem mnuTwirl;
        private MenuItem menuItem12;
        private MenuItem mnuSolarize;
        private MenuItem mnuWaterRipple;
        private MenuItem mnuShear;
        private MenuItem mnuSphere;
        private MenuItem mnuMarble;
        private MenuItem mnuShake;
        private MenuItem mnuCustomerFilter;
        private MenuItem mnuAutoColorEnhance;
        private MenuItem mnuBomb;
        private MenuItem menuItem6;
        private MenuItem mnuOil;
        private MenuItem mnuSpreadNoise;
        private MenuItem mnuRedEyeRemoval;
        private MenuItem menuItem14;
        private MenuItem mnuGradientBorder;
        private MenuItem mnuTextureBorder;
        private StatusBarPanel statusPalCurrent;
        private StatusBarPanel statusPalAddon;
        private StatusBar statusBar;
        private StatusBarPanel statusProcessingPanel;
        private MenuItem mnuWind;
        private MenuItem mnuEnableProgress;
        private MenuItem mnuLinearBlur;
        private MenuItem mnuRadialBlur;
        private MenuItem mnuZoomBlur;
        private ProgressBar barProgress;

        #endregion

        //local variables
        private bool Modified = false;	// if the picture is modified, it will be true
        public string FileName = "";		// stores the picture's file name
        private bool bBlocking = false;	// marks the mouse is pressed down on the pic
        private Point ptBeg, ptEnd;

        #region Windows form functions
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new frmMain());
        }

        public frmMain()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmMain));
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.mnuOpen = new System.Windows.Forms.MenuItem();
            this.mnuSave = new System.Windows.Forms.MenuItem();
            this.mnuSaveGif = new System.Windows.Forms.MenuItem();
            this.mnuSettings = new System.Windows.Forms.MenuItem();
            this.mnuBackgroundColor = new System.Windows.Forms.MenuItem();
            this.mnuEnableProgress = new System.Windows.Forms.MenuItem();
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.mnuExit = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.mnuReset = new System.Windows.Forms.MenuItem();
            this.menuItem4 = new System.Windows.Forms.MenuItem();
            this.mnuResize = new System.Windows.Forms.MenuItem();
            this.mnuRotate = new System.Windows.Forms.MenuItem();
            this.mnuFlip = new System.Windows.Forms.MenuItem();
            this.mnuCrop = new System.Windows.Forms.MenuItem();
            this.mnuCanvas = new System.Windows.Forms.MenuItem();
            this.menuScale = new System.Windows.Forms.MenuItem();
            this.menuItem13 = new System.Windows.Forms.MenuItem();
            this.mnuAdjust = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.mnuTransparent = new System.Windows.Forms.MenuItem();
            this.mnuGray = new System.Windows.Forms.MenuItem();
            this.mnuGrey = new System.Windows.Forms.MenuItem();
            this.mnuInvert = new System.Windows.Forms.MenuItem();
            this.mnuSepia = new System.Windows.Forms.MenuItem();
            this.mnuBlackWhite = new System.Windows.Forms.MenuItem();
            this.mnuContrast = new System.Windows.Forms.MenuItem();
            this.mnuGamma = new System.Windows.Forms.MenuItem();
            this.mnuHSL = new System.Windows.Forms.MenuItem();
            this.mnuAutoColorEnhance = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.mnuBlurGroup = new System.Windows.Forms.MenuItem();
            this.mnuDeepBlur = new System.Windows.Forms.MenuItem();
            this.mnuBlur = new System.Windows.Forms.MenuItem();
            this.mnuSmooth = new System.Windows.Forms.MenuItem();
            this.mnuSharpenGroup = new System.Windows.Forms.MenuItem();
            this.mnuMeanRemoval = new System.Windows.Forms.MenuItem();
            this.mnuSharpen = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.mnuNoise = new System.Windows.Forms.MenuItem();
            this.mnuSpreadNoise = new System.Windows.Forms.MenuItem();
            this.mnuDistortGroup = new System.Windows.Forms.MenuItem();
            this.mnuDiffuse = new System.Windows.Forms.MenuItem();
            this.mnuDither = new System.Windows.Forms.MenuItem();
            this.mnuMosaic = new System.Windows.Forms.MenuItem();
            this.mnuShear = new System.Windows.Forms.MenuItem();
            this.mnuShake = new System.Windows.Forms.MenuItem();
            this.mnuSphere = new System.Windows.Forms.MenuItem();
            this.mnuStylizeGroup = new System.Windows.Forms.MenuItem();
            this.mnuEmboss = new System.Windows.Forms.MenuItem();
            this.mnuEngrave = new System.Windows.Forms.MenuItem();
            this.mnuGlassBorder = new System.Windows.Forms.MenuItem();
            this.mnuTwirl = new System.Windows.Forms.MenuItem();
            this.mnuWater = new System.Windows.Forms.MenuItem();
            this.mnuWaterRipple = new System.Windows.Forms.MenuItem();
            this.mnuMarble = new System.Windows.Forms.MenuItem();
            this.mnuBomb = new System.Windows.Forms.MenuItem();
            this.mnuOil = new System.Windows.Forms.MenuItem();
            this.mnuWind = new System.Windows.Forms.MenuItem();
            this.mnuEdgeDetection = new System.Windows.Forms.MenuItem();
            this.mnuEDSobel = new System.Windows.Forms.MenuItem();
            this.mnuEDPrewiit = new System.Windows.Forms.MenuItem();
            this.mnuEDKirsh = new System.Windows.Forms.MenuItem();
            this.EDFreiChen = new System.Windows.Forms.MenuItem();
            this.mnuEDRoberts = new System.Windows.Forms.MenuItem();
            this.mnuEDDifference = new System.Windows.Forms.MenuItem();
            this.mnuRender = new System.Windows.Forms.MenuItem();
            this.mnuDarkness = new System.Windows.Forms.MenuItem();
            this.mnuLightness = new System.Windows.Forms.MenuItem();
            this.mnuSolarize = new System.Windows.Forms.MenuItem();
            this.mnuRedEyeRemoval = new System.Windows.Forms.MenuItem();
            this.mnuCustomerFilter = new System.Windows.Forms.MenuItem();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.mnuFeather = new System.Windows.Forms.MenuItem();
            this.mnuFeather1 = new System.Windows.Forms.MenuItem();
            this.mnuFeather2 = new System.Windows.Forms.MenuItem();
            this.menuItem12 = new System.Windows.Forms.MenuItem();
            this.mnuFeather3 = new System.Windows.Forms.MenuItem();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.mnuSetBorder = new System.Windows.Forms.MenuItem();
            this.menuItem14 = new System.Windows.Forms.MenuItem();
            this.mnuGradientBorder = new System.Windows.Forms.MenuItem();
            this.mnuTextureBorder = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.mnuAbout = new System.Windows.Forms.MenuItem();
            this.toolBar = new System.Windows.Forms.ToolBar();
            this.tbOpen = new System.Windows.Forms.ToolBarButton();
            this.tbSave = new System.Windows.Forms.ToolBarButton();
            this.tbReset = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
            this.tbCrop = new System.Windows.Forms.ToolBarButton();
            this.tbResize = new System.Windows.Forms.ToolBarButton();
            this.tbRotate = new System.Windows.Forms.ToolBarButton();
            this.tbFlip = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton3 = new System.Windows.Forms.ToolBarButton();
            this.tbColorAdjust = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton4 = new System.Windows.Forms.ToolBarButton();
            this.imgList = new System.Windows.Forms.ImageList(this.components);
            this.palMain = new System.Windows.Forms.Panel();
            this.pic = new System.Windows.Forms.PictureBox();
            this.dlgFile = new System.Windows.Forms.OpenFileDialog();
            this.dlgSave = new System.Windows.Forms.SaveFileDialog();
            this.dlgColor = new System.Windows.Forms.ColorDialog();
            this.statusPalCurrent = new System.Windows.Forms.StatusBarPanel();
            this.statusPalAddon = new System.Windows.Forms.StatusBarPanel();
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.barProgress = new System.Windows.Forms.ProgressBar();
            this.statusProcessingPanel = new System.Windows.Forms.StatusBarPanel();
            this.mnuLinearBlur = new System.Windows.Forms.MenuItem();
            this.mnuRadialBlur = new System.Windows.Forms.MenuItem();
            this.mnuZoomBlur = new System.Windows.Forms.MenuItem();
            this.palMain.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pic)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPalCurrent)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPalAddon)).BeginInit();
            this.statusBar.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.statusProcessingPanel)).BeginInit();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1,
            this.menuItem5,
            this.menuItem13,
            this.menuItem11,
            this.menuItem7,
            this.menuItem10});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuOpen,
            this.mnuSave,
            this.mnuSaveGif,
            this.mnuSettings,
            this.menuItem3,
            this.mnuExit});
            this.menuItem1.Text = "File";
            // 
            // mnuOpen
            // 
            this.mnuOpen.Index = 0;
            this.mnuOpen.Text = "Open";
            this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
            // 
            // mnuSave
            // 
            this.mnuSave.Index = 1;
            this.mnuSave.Text = "Save to JPG";
            this.mnuSave.Click += new System.EventHandler(this.mnuSave_Click);
            // 
            // mnuSaveGif
            // 
            this.mnuSaveGif.Index = 2;
            this.mnuSaveGif.Text = "Save to GIF";
            this.mnuSaveGif.Click += new System.EventHandler(this.mnuSaveGif_Click);
            // 
            // mnuSettings
            // 
            this.mnuSettings.Index = 3;
            this.mnuSettings.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuBackgroundColor,
            this.mnuEnableProgress});
            this.mnuSettings.Text = "Settings";
            // 
            // mnuBackgroundColor
            // 
            this.mnuBackgroundColor.Index = 0;
            this.mnuBackgroundColor.Text = "Background Color";
            this.mnuBackgroundColor.Click += new System.EventHandler(this.mnuBackgroundColor_Click);
            // 
            // mnuEnableProgress
            // 
            this.mnuEnableProgress.Index = 1;
            this.mnuEnableProgress.Text = "Enable Progress";
            this.mnuEnableProgress.Click += new System.EventHandler(this.mnuEnableProgress_Click);
            // 
            // menuItem3
            // 
            this.menuItem3.Index = 4;
            this.menuItem3.Text = "-";
            // 
            // mnuExit
            // 
            this.mnuExit.Index = 5;
            this.mnuExit.Text = "Exit";
            this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
            // 
            // menuItem5
            // 
            this.menuItem5.Index = 1;
            this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuReset,
            this.menuItem4,
            this.mnuResize,
            this.mnuRotate,
            this.mnuFlip,
            this.mnuCrop,
            this.mnuCanvas,
            this.menuScale});
            this.menuItem5.Text = "Image";
            // 
            // mnuReset
            // 
            this.mnuReset.Enabled = false;
            this.mnuReset.Index = 0;
            this.mnuReset.Text = "Reset";
            this.mnuReset.Click += new System.EventHandler(this.mnuReset_Click);
            // 
            // menuItem4
            // 
            this.menuItem4.Index = 1;
            this.menuItem4.Text = "-";
            // 
            // mnuResize
            // 
            this.mnuResize.Index = 2;
            this.mnuResize.Text = "Resize";
            this.mnuResize.Click += new System.EventHandler(this.mnuResize_Click);
            // 
            // mnuRotate
            // 
            this.mnuRotate.Index = 3;
            this.mnuRotate.Text = "Rotate";
            this.mnuRotate.Click += new System.EventHandler(this.mnuRotate_Click);
            // 
            // mnuFlip
            // 
            this.mnuFlip.Index = 4;
            this.mnuFlip.Text = "Flip";
            this.mnuFlip.Click += new System.EventHandler(this.mnuFlip_Click);
            // 
            // mnuCrop
            // 
            this.mnuCrop.Index = 5;
            this.mnuCrop.Text = "Crop";
            this.mnuCrop.Click += new System.EventHandler(this.mnuCrop_Click);
            // 
            // mnuCanvas
            // 
            this.mnuCanvas.Index = 6;
            this.mnuCanvas.Text = "Canvas Size";
            this.mnuCanvas.Click += new System.EventHandler(this.mnuCanvas_Click);
            // 
            // menuScale
            // 
            this.menuScale.Index = 7;
            this.menuScale.Text = "Scale";
            this.menuScale.Click += new System.EventHandler(this.menuScale_Click);
            // 
            // menuItem13
            // 
            this.menuItem13.Index = 2;
            this.menuItem13.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAdjust,
            this.menuItem2,
            this.mnuTransparent,
            this.mnuGray,
            this.mnuGrey,
            this.mnuInvert,
            this.mnuSepia,
            this.mnuBlackWhite,
            this.mnuContrast,
            this.mnuGamma,
            this.mnuHSL,
            this.mnuAutoColorEnhance});
            this.menuItem13.Text = "Adjust";
            // 
            // mnuAdjust
            // 
            this.mnuAdjust.Index = 0;
            this.mnuAdjust.Text = "Color Adjust";
            this.mnuAdjust.Click += new System.EventHandler(this.mnuAdjust_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.Text = "-";
            // 
            // mnuTransparent
            // 
            this.mnuTransparent.Index = 2;
            this.mnuTransparent.Text = "Tranparent";
            this.mnuTransparent.Click += new System.EventHandler(this.mnuTransparent_Click);
            // 
            // mnuGray
            // 
            this.mnuGray.Index = 3;
            this.mnuGray.Text = "GrayScale";
            this.mnuGray.Click += new System.EventHandler(this.mnuGray_Click);
            // 
            // mnuGrey
            // 
            this.mnuGrey.Index = 4;
            this.mnuGrey.Text = "Grey";
            this.mnuGrey.Click += new System.EventHandler(this.mnuGrey_Click);
            // 
            // mnuInvert
            // 
            this.mnuInvert.Index = 5;
            this.mnuInvert.Text = "Invert";
            this.mnuInvert.Click += new System.EventHandler(this.mnuInvert_Click);
            // 
            // mnuSepia
            // 
            this.mnuSepia.Index = 6;
            this.mnuSepia.Text = "Sepia";
            this.mnuSepia.Click += new System.EventHandler(this.mnuSepia_Click);
            // 
            // mnuBlackWhite
            // 
            this.mnuBlackWhite.Index = 7;
            this.mnuBlackWhite.Text = "BlackWhite";
            this.mnuBlackWhite.Click += new System.EventHandler(this.mnuBlackWhite_Click);
            // 
            // mnuContrast
            // 
            this.mnuContrast.Index = 8;
            this.mnuContrast.Text = "Contrast";
            this.mnuContrast.Click += new System.EventHandler(this.mnuContrast_Click);
            // 
            // mnuGamma
            // 
            this.mnuGamma.Index = 9;
            this.mnuGamma.Text = "Gamma";
            this.mnuGamma.Click += new System.EventHandler(this.mnuGamma_Click);
            // 
            // mnuHSL
            // 
            this.mnuHSL.Index = 10;
            this.mnuHSL.Text = "HSL";
            this.mnuHSL.Click += new System.EventHandler(this.mnuHSL_Click);
            // 
            // mnuAutoColorEnhance
            // 
            this.mnuAutoColorEnhance.Index = 11;
            this.mnuAutoColorEnhance.Text = "AutoColor Enhance";
            this.mnuAutoColorEnhance.Click += new System.EventHandler(this.mnuAutoColorEnhance_Click);
            // 
            // menuItem11
            // 
            this.menuItem11.Index = 3;
            this.menuItem11.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuBlurGroup,
            this.mnuSharpenGroup,
            this.menuItem6,
            this.mnuDistortGroup,
            this.mnuStylizeGroup,
            this.mnuEdgeDetection,
            this.mnuRender,
            this.mnuCustomerFilter,
            this.menuItem8,
            this.mnuFeather});
            this.menuItem11.Text = "Filter";
            // 
            // mnuBlurGroup
            // 
            this.mnuBlurGroup.Index = 0;
            this.mnuBlurGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuDeepBlur,
            this.mnuBlur,
            this.mnuLinearBlur,
            this.mnuRadialBlur,
            this.mnuSmooth,
            this.mnuZoomBlur});
            this.mnuBlurGroup.Text = "Blur";
            // 
            // mnuDeepBlur
            // 
            this.mnuDeepBlur.Index = 0;
            this.mnuDeepBlur.Text = "Deep Blur";
            this.mnuDeepBlur.Click += new System.EventHandler(this.mnuDirtyBlur_Click);
            // 
            // mnuBlur
            // 
            this.mnuBlur.Index = 1;
            this.mnuBlur.Text = "Gaussian Blur";
            this.mnuBlur.Click += new System.EventHandler(this.mnuBlur_Click);
            // 
            // mnuSmooth
            // 
            this.mnuSmooth.Index = 4;
            this.mnuSmooth.Text = "Smooth";
            this.mnuSmooth.Click += new System.EventHandler(this.mnuSmooth_Click);
            // 
            // mnuSharpenGroup
            // 
            this.mnuSharpenGroup.Index = 1;
            this.mnuSharpenGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuMeanRemoval,
            this.mnuSharpen});
            this.mnuSharpenGroup.Text = "Sharpen";
            // 
            // mnuMeanRemoval
            // 
            this.mnuMeanRemoval.Index = 0;
            this.mnuMeanRemoval.Text = "MeanRemoval";
            this.mnuMeanRemoval.Click += new System.EventHandler(this.mnuMeanRemoval_Click);
            // 
            // mnuSharpen
            // 
            this.mnuSharpen.Index = 1;
            this.mnuSharpen.Text = "Sharpen";
            this.mnuSharpen.Click += new System.EventHandler(this.mnuSharpen_Click);
            // 
            // menuItem6
            // 
            this.menuItem6.Index = 2;
            this.menuItem6.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuNoise,
            this.mnuSpreadNoise});
            this.menuItem6.Text = "Noise";
            // 
            // mnuNoise
            // 
            this.mnuNoise.Index = 0;
            this.mnuNoise.Text = "Noise";
            this.mnuNoise.Click += new System.EventHandler(this.mnuNoise_Click);
            // 
            // mnuSpreadNoise
            // 
            this.mnuSpreadNoise.Index = 1;
            this.mnuSpreadNoise.Text = "Spread Noise";
            this.mnuSpreadNoise.Click += new System.EventHandler(this.mnuSpreadNoise_Click);
            // 
            // mnuDistortGroup
            // 
            this.mnuDistortGroup.Index = 3;
            this.mnuDistortGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuDiffuse,
            this.mnuDither,
            this.mnuMosaic,
            this.mnuShear,
            this.mnuShake,
            this.mnuSphere});
            this.mnuDistortGroup.Text = "Distort";
            // 
            // mnuDiffuse
            // 
            this.mnuDiffuse.Index = 0;
            this.mnuDiffuse.Text = "Diffuse";
            this.mnuDiffuse.Click += new System.EventHandler(this.mnuDiffuse_Click);
            // 
            // mnuDither
            // 
            this.mnuDither.Index = 1;
            this.mnuDither.Text = "Dither";
            this.mnuDither.Click += new System.EventHandler(this.mnuDither_Click);
            // 
            // mnuMosaic
            // 
            this.mnuMosaic.Index = 2;
            this.mnuMosaic.Text = "Mosaic";
            this.mnuMosaic.Click += new System.EventHandler(this.mnuMosaicNormal_Click);
            // 
            // mnuShear
            // 
            this.mnuShear.Index = 3;
            this.mnuShear.Text = "Shear";
            this.mnuShear.Click += new System.EventHandler(this.mnuShear_Click);
            // 
            // mnuShake
            // 
            this.mnuShake.Index = 4;
            this.mnuShake.Text = "Shake";
            this.mnuShake.Click += new System.EventHandler(this.mnuShake_Click);
            // 
            // mnuSphere
            // 
            this.mnuSphere.Index = 5;
            this.mnuSphere.Text = "Sphere";
            this.mnuSphere.Click += new System.EventHandler(this.mnuSphere_Click);
            // 
            // mnuStylizeGroup
            // 
            this.mnuStylizeGroup.Index = 4;
            this.mnuStylizeGroup.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuEmboss,
            this.mnuEngrave,
            this.mnuGlassBorder,
            this.mnuTwirl,
            this.mnuWater,
            this.mnuWaterRipple,
            this.mnuMarble,
            this.mnuBomb,
            this.mnuOil,
            this.mnuWind});
            this.mnuStylizeGroup.Text = "Stylize";
            // 
            // mnuEmboss
            // 
            this.mnuEmboss.Index = 0;
            this.mnuEmboss.Text = "Emboss";
            this.mnuEmboss.Click += new System.EventHandler(this.mnuEmboss_Click);
            // 
            // mnuEngrave
            // 
            this.mnuEngrave.Index = 1;
            this.mnuEngrave.Text = "Engrave";
            this.mnuEngrave.Click += new System.EventHandler(this.mnuEngrave_Click);
            // 
            // mnuGlassBorder
            // 
            this.mnuGlassBorder.Index = 2;
            this.mnuGlassBorder.Text = "GlassBorder";
            this.mnuGlassBorder.Click += new System.EventHandler(this.mnuGlassBorder_Click);
            // 
            // mnuTwirl
            // 
            this.mnuTwirl.Index = 3;
            this.mnuTwirl.Text = "Twirl";
            this.mnuTwirl.Click += new System.EventHandler(this.mnuTwirl_Click);
            // 
            // mnuWater
            // 
            this.mnuWater.Index = 4;
            this.mnuWater.Text = "Water";
            this.mnuWater.Click += new System.EventHandler(this.mnuWater_Click);
            // 
            // mnuWaterRipple
            // 
            this.mnuWaterRipple.Index = 5;
            this.mnuWaterRipple.Text = "WaterRipple";
            this.mnuWaterRipple.Click += new System.EventHandler(this.mnuWaterRipple_Click);
            // 
            // mnuMarble
            // 
            this.mnuMarble.Index = 6;
            this.mnuMarble.Text = "Marble";
            this.mnuMarble.Click += new System.EventHandler(this.mnuMarble_Click);
            // 
            // mnuBomb
            // 
            this.mnuBomb.Index = 7;
            this.mnuBomb.Text = "Bomb";
            this.mnuBomb.Click += new System.EventHandler(this.mnuBomb_Click);
            // 
            // mnuOil
            // 
            this.mnuOil.Index = 8;
            this.mnuOil.Text = "Oil";
            this.mnuOil.Click += new System.EventHandler(this.mnuOil_Click);
            // 
            // mnuWind
            // 
            this.mnuWind.Index = 9;
            this.mnuWind.Text = "Wind";
            this.mnuWind.Click += new System.EventHandler(this.mnuWind_Click);
            // 
            // mnuEdgeDetection
            // 
            this.mnuEdgeDetection.Index = 5;
            this.mnuEdgeDetection.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuEDSobel,
            this.mnuEDPrewiit,
            this.mnuEDKirsh,
            this.EDFreiChen,
            this.mnuEDRoberts,
            this.mnuEDDifference});
            this.mnuEdgeDetection.Text = "EdgeDetection";
            // 
            // mnuEDSobel
            // 
            this.mnuEDSobel.Index = 0;
            this.mnuEDSobel.Text = "EdgeDetectSobel";
            this.mnuEDSobel.Click += new System.EventHandler(this.mnuEDSobel_Click);
            // 
            // mnuEDPrewiit
            // 
            this.mnuEDPrewiit.Index = 1;
            this.mnuEDPrewiit.Text = "EdgeDetectPrewitt";
            this.mnuEDPrewiit.Click += new System.EventHandler(this.mnuEDPrewiit_Click);
            // 
            // mnuEDKirsh
            // 
            this.mnuEDKirsh.Index = 2;
            this.mnuEDKirsh.Text = "EdgeDetectKirsh";
            this.mnuEDKirsh.Click += new System.EventHandler(this.mnuEDKirsh_Click);
            // 
            // EDFreiChen
            // 
            this.EDFreiChen.Index = 3;
            this.EDFreiChen.Text = "EdgeDetectFreiChen";
            this.EDFreiChen.Click += new System.EventHandler(this.EdgeDetectFreiChen_Click);
            // 
            // mnuEDRoberts
            // 
            this.mnuEDRoberts.Index = 4;
            this.mnuEDRoberts.Text = "EdgeDetectRoberts";
            this.mnuEDRoberts.Click += new System.EventHandler(this.mnuEDRoberts_Click);
            // 
            // mnuEDDifference
            // 
            this.mnuEDDifference.Index = 5;
            this.mnuEDDifference.Text = "EdgeDetectDifference";
            this.mnuEDDifference.Click += new System.EventHandler(this.mnuEDDifference_Click);
            // 
            // mnuRender
            // 
            this.mnuRender.Index = 6;
            this.mnuRender.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuDarkness,
            this.mnuLightness,
            this.mnuSolarize,
            this.mnuRedEyeRemoval});
            this.mnuRender.Text = "Render";
            // 
            // mnuDarkness
            // 
            this.mnuDarkness.Index = 0;
            this.mnuDarkness.Text = "Darkness";
            this.mnuDarkness.Click += new System.EventHandler(this.mnuDarkness_Click);
            // 
            // mnuLightness
            // 
            this.mnuLightness.Index = 1;
            this.mnuLightness.Text = "Lightness";
            this.mnuLightness.Click += new System.EventHandler(this.mnuLightness_Click);
            // 
            // mnuSolarize
            // 
            this.mnuSolarize.Index = 2;
            this.mnuSolarize.Text = "Solarize";
            this.mnuSolarize.Click += new System.EventHandler(this.mnuSolarize_Click);
            // 
            // mnuRedEyeRemoval
            // 
            this.mnuRedEyeRemoval.Index = 3;
            this.mnuRedEyeRemoval.Text = "RedEye Removal";
            this.mnuRedEyeRemoval.Click += new System.EventHandler(this.mnuRedEyeRemoval_Click);
            // 
            // mnuCustomerFilter
            // 
            this.mnuCustomerFilter.Index = 7;
            this.mnuCustomerFilter.Text = "Customer";
            this.mnuCustomerFilter.Click += new System.EventHandler(this.mnuCustomerFilter_Click);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = 8;
            this.menuItem8.Text = "-";
            // 
            // mnuFeather
            // 
            this.mnuFeather.Index = 9;
            this.mnuFeather.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFeather1,
            this.mnuFeather2,
            this.menuItem12,
            this.mnuFeather3});
            this.mnuFeather.Text = "Feather";
            // 
            // mnuFeather1
            // 
            this.mnuFeather1.Index = 0;
            this.mnuFeather1.Text = "Do Feather with Selected Rectangle";
            this.mnuFeather1.Click += new System.EventHandler(this.mnuFeather1_Click);
            // 
            // mnuFeather2
            // 
            this.mnuFeather2.Index = 1;
            this.mnuFeather2.Text = "Frame with a Feather Way";
            this.mnuFeather2.Click += new System.EventHandler(this.mnuFeather2_Click);
            // 
            // menuItem12
            // 
            this.menuItem12.Index = 2;
            this.menuItem12.Text = "-";
            // 
            // mnuFeather3
            // 
            this.mnuFeather3.Index = 3;
            this.mnuFeather3.Text = "Configurate Feather Builder";
            this.mnuFeather3.Click += new System.EventHandler(this.mnuFeather3_Click);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = 4;
            this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuSetBorder,
            this.menuItem14,
            this.mnuGradientBorder,
            this.mnuTextureBorder});
            this.menuItem7.Text = "Border";
            // 
            // mnuSetBorder
            // 
            this.mnuSetBorder.Index = 0;
            this.mnuSetBorder.Text = "Set Border";
            this.mnuSetBorder.Click += new System.EventHandler(this.mnuSetBorder_Click);
            // 
            // menuItem14
            // 
            this.menuItem14.Index = 1;
            this.menuItem14.Text = "-";
            // 
            // mnuGradientBorder
            // 
            this.mnuGradientBorder.Index = 2;
            this.mnuGradientBorder.Text = "Gradient Border";
            this.mnuGradientBorder.Click += new System.EventHandler(this.mnuGradientBorder_Click);
            // 
            // mnuTextureBorder
            // 
            this.mnuTextureBorder.Index = 3;
            this.mnuTextureBorder.Text = "Texture Border";
            this.mnuTextureBorder.Click += new System.EventHandler(this.mnuTextureBorder_Click);
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 5;
            this.menuItem10.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAbout});
            this.menuItem10.Text = "Help";
            // 
            // mnuAbout
            // 
            this.mnuAbout.Index = 0;
            this.mnuAbout.Text = "About";
            this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
            // 
            // toolBar
            // 
            this.toolBar.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.tbOpen,
            this.tbSave,
            this.tbReset,
            this.toolBarButton1,
            this.tbCrop,
            this.tbResize,
            this.tbRotate,
            this.tbFlip,
            this.toolBarButton3,
            this.tbColorAdjust,
            this.toolBarButton4});
            this.toolBar.DropDownArrows = true;
            this.toolBar.ImageList = this.imgList;
            this.toolBar.Location = new System.Drawing.Point(0, 0);
            this.toolBar.Name = "toolBar";
            this.toolBar.ShowToolTips = true;
            this.toolBar.Size = new System.Drawing.Size(656, 59);
            this.toolBar.TabIndex = 0;
            this.toolBar.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_ButtonClick);
            // 
            // tbOpen
            // 
            this.tbOpen.ImageIndex = 0;
            this.tbOpen.Name = "tbOpen";
            this.tbOpen.Text = "Open";
            this.tbOpen.ToolTipText = "Open the photo file";
            // 
            // tbSave
            // 
            this.tbSave.ImageIndex = 1;
            this.tbSave.Name = "tbSave";
            this.tbSave.Text = "Save";
            this.tbSave.ToolTipText = "Save the edited photo";
            // 
            // tbReset
            // 
            this.tbReset.ImageIndex = 7;
            this.tbReset.Name = "tbReset";
            this.tbReset.Text = "Reset";
            this.tbReset.ToolTipText = "Reset";
            // 
            // toolBarButton1
            // 
            this.toolBarButton1.Name = "toolBarButton1";
            this.toolBarButton1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbCrop
            // 
            this.tbCrop.ImageIndex = 5;
            this.tbCrop.Name = "tbCrop";
            this.tbCrop.Text = "Crop";
            this.tbCrop.ToolTipText = "Crop the photo";
            // 
            // tbResize
            // 
            this.tbResize.ImageIndex = 6;
            this.tbResize.Name = "tbResize";
            this.tbResize.Text = "Resize";
            this.tbResize.ToolTipText = "Resize";
            // 
            // tbRotate
            // 
            this.tbRotate.ImageIndex = 3;
            this.tbRotate.Name = "tbRotate";
            this.tbRotate.Text = "Rotate";
            this.tbRotate.ToolTipText = "Rotate";
            // 
            // tbFlip
            // 
            this.tbFlip.ImageIndex = 4;
            this.tbFlip.Name = "tbFlip";
            this.tbFlip.Text = "Flip";
            this.tbFlip.ToolTipText = "Flip";
            // 
            // toolBarButton3
            // 
            this.toolBarButton3.Name = "toolBarButton3";
            this.toolBarButton3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // tbColorAdjust
            // 
            this.tbColorAdjust.ImageIndex = 8;
            this.tbColorAdjust.Name = "tbColorAdjust";
            this.tbColorAdjust.Text = "ColorAdjust";
            this.tbColorAdjust.ToolTipText = "ColorAdjust";
            // 
            // toolBarButton4
            // 
            this.toolBarButton4.Name = "toolBarButton4";
            this.toolBarButton4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // imgList
            // 
            this.imgList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgList.ImageStream")));
            this.imgList.TransparentColor = System.Drawing.Color.Transparent;
            this.imgList.Images.SetKeyName(0, "");
            this.imgList.Images.SetKeyName(1, "");
            this.imgList.Images.SetKeyName(2, "");
            this.imgList.Images.SetKeyName(3, "");
            this.imgList.Images.SetKeyName(4, "");
            this.imgList.Images.SetKeyName(5, "");
            this.imgList.Images.SetKeyName(6, "");
            this.imgList.Images.SetKeyName(7, "");
            this.imgList.Images.SetKeyName(8, "");
            // 
            // palMain
            // 
            this.palMain.AutoScroll = true;
            this.palMain.BackColor = System.Drawing.Color.Black;
            this.palMain.Controls.Add(this.pic);
            this.palMain.Cursor = System.Windows.Forms.Cursors.Default;
            this.palMain.Dock = System.Windows.Forms.DockStyle.Fill;
            this.palMain.Location = new System.Drawing.Point(0, 59);
            this.palMain.Name = "palMain";
            this.palMain.Size = new System.Drawing.Size(656, 380);
            this.palMain.TabIndex = 2;
            // 
            // pic
            // 
            this.pic.BackColor = System.Drawing.Color.Transparent;
            this.pic.Location = new System.Drawing.Point(0, 0);
            this.pic.Name = "pic";
            this.pic.Size = new System.Drawing.Size(656, 383);
            this.pic.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
            this.pic.TabIndex = 0;
            this.pic.TabStop = false;
            this.pic.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pic_MouseDown);
            this.pic.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pic_MouseMove);
            this.pic.Paint += new System.Windows.Forms.PaintEventHandler(this.pic_Paint);
            this.pic.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pic_MouseUp);
            this.pic.SizeChanged += new System.EventHandler(this.pic_SizeChanged);
            // 
            // dlgFile
            // 
            this.dlgFile.DefaultExt = "*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF;*.TIFF";
            this.dlgFile.Filter = "Image Files(*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF;*.TIFF)|*.JPEG;*.JPG;*.BMP;*.GIF;*.TIF" +
                ";*.TIFF)|All Files(*.*)|*.*";
            // 
            // dlgSave
            // 
            this.dlgSave.DefaultExt = "*.jpg";
            this.dlgSave.Filter = "Jpeg File(*.JPEG;*.JPG)|*.JPEG;*.JPG";
            // 
            // dlgColor
            // 
            this.dlgColor.AnyColor = true;
            this.dlgColor.Color = System.Drawing.Color.Transparent;
            this.dlgColor.FullOpen = true;
            // 
            // statusPalCurrent
            // 
            this.statusPalCurrent.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
            this.statusPalCurrent.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
            this.statusPalCurrent.Name = "statusPalCurrent";
            this.statusPalCurrent.Width = 10;
            // 
            // statusPalAddon
            // 
            this.statusPalAddon.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.statusPalAddon.Name = "statusPalAddon";
            this.statusPalAddon.Width = 530;
            // 
            // statusBar
            // 
            this.statusBar.Controls.Add(this.barProgress);
            this.statusBar.Location = new System.Drawing.Point(0, 439);
            this.statusBar.Name = "statusBar";
            this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
            this.statusProcessingPanel,
            this.statusPalAddon,
            this.statusPalCurrent});
            this.statusBar.ShowPanels = true;
            this.statusBar.Size = new System.Drawing.Size(656, 22);
            this.statusBar.TabIndex = 1;
            // 
            // barProgress
            // 
            this.barProgress.Location = new System.Drawing.Point(0, 0);
            this.barProgress.Name = "barProgress";
            this.barProgress.Size = new System.Drawing.Size(100, 23);
            this.barProgress.Step = 1;
            this.barProgress.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
            this.barProgress.TabIndex = 0;
            // 
            // statusProcessingPanel
            // 
            this.statusProcessingPanel.Name = "statusProcessingPanel";
            // 
            // mnuLinearBlur
            // 
            this.mnuLinearBlur.Index = 2;
            this.mnuLinearBlur.Text = "Linear Blur";
            this.mnuLinearBlur.Click += new System.EventHandler(this.mnuLinearBlur_Click);
            // 
            // mnuRadialBlur
            // 
            this.mnuRadialBlur.Index = 3;
            this.mnuRadialBlur.Text = "Radial Blur";
            this.mnuRadialBlur.Click += new System.EventHandler(this.mnuRadialBlur_Click);
            // 
            // mnuZoomBlur
            // 
            this.mnuZoomBlur.Index = 5;
            this.mnuZoomBlur.Text = "Zoom Blur";
            this.mnuZoomBlur.Click += new System.EventHandler(this.mnuZoomBlur_Click);
            // 
            // frmMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.AutoScroll = true;
            this.AutoScrollMinSize = new System.Drawing.Size(10, 10);
            this.ClientSize = new System.Drawing.Size(656, 461);
            this.Controls.Add(this.palMain);
            this.Controls.Add(this.statusBar);
            this.Controls.Add(this.toolBar);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.mainMenu;
            this.Name = "frmMain";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "PhotoGear";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
            this.Load += new System.EventHandler(this.Form2_Load);
            this.palMain.ResumeLayout(false);
            this.palMain.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pic)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPalCurrent)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusPalAddon)).EndInit();
            this.statusBar.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.statusProcessingPanel)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        #region private helper methods
        protected void setReset(bool enable)
        {
            mnuReset.Enabled = enable;
            tbReset.Enabled = enable;
        }

        protected void setSave(bool enable)
        {
            tbSave.Enabled = enable;
            mnuSave.Enabled = enable;
        }

        protected void setRefresh(bool enable)
        {
            pic.Refresh();
            Modified = enable;
            setReset(enable);
            //setSave(enable);
        }
        #endregion

        #region Form related methods, such open dialog, close, toolbar button click

        private void Form2_Load(object sender, EventArgs e)
        {
            setReset(false);
        }

        private void toolBar_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if (e.Button == this.tbOpen)
                mnuOpen_Click(sender, e);

            if (e.Button == this.tbResize)
                mnuResize_Click(sender, e);

            if (e.Button == this.tbReset)
                mnuReset_Click(sender, e);

            if (e.Button == this.tbRotate)
                mnuRotate_Click(sender, e);

            if (e.Button == this.tbFlip)
                mnuFlip_Click(sender, e);

            if (e.Button == this.tbSave)
                mnuSave_Click(sender, e);

            if (e.Button == this.tbCrop)
                mnuCrop_Click(sender, e);

            if (e.Button == this.tbColorAdjust)
                mnuAdjust_Click(sender, e);
        }

        private void mnuReset_Click(object sender, EventArgs e)
        {
            if (FileName.Trim() == "") return;
            pic.Image = Image.FromFile(FileName, true);
            setRefresh(false);
        }

        private void mnuAbout_Click(object sender, EventArgs e)
        {
            new frmAbout().ShowDialog();
        }

        private void frmMain_Closing(object sender, CancelEventArgs e)
        {
            if (Modified)
                if (Helper.Ask("Do you want to save the image?"))
                {
                    this.mnuSave_Click(sender, e);
                }

        }

        private void mnuOpen_Click(object sender, EventArgs e)
        {
            dlgFile.ShowDialog();
            if (dlgFile.FileName != "")
            {
                palMain.AutoScroll = false;
                FileName = dlgFile.FileName;
                Image img = Image.FromFile(dlgFile.FileName,true);
                pic.Image = (Image)img.Clone();
                // dispose img so that we can overwrite the original file
                img.Dispose();
                this.statusPalCurrent.Text = "Current Image:" + pic.Image.Width.ToString() + "X" + pic.Image.Height.ToString() + "X" + pic.Image.PixelFormat.ToString();
                this.statusPalAddon.Text = "";
                pic_SizeChanged(sender, e);
            }
        }

        private void mnuExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void pic_SizeChanged(object sender, EventArgs e)
        {
            if (pic.Image == null) return;
            palMain.AutoScroll = true;

            if (pic.Image.Width >= palMain.Width)
                pic.Left = 0;
            else
                pic.Left = palMain.Width / 2 - pic.Image.Width / 2;

            if (pic.Image.Height >= palMain.Height)
                pic.Top = 0;
            else
                pic.Top = palMain.Height / 2 - pic.Image.Height / 2;
        }

        // this method sets a different background color for the centre picture
        private void mnuBackgroundColor_Click(object sender, EventArgs e)
        {
            if (dlgColor.ShowDialog() == DialogResult.OK)
            {
                palMain.BackColor = dlgColor.Color;
                pic.BackColor = dlgColor.Color;
            }
        }

        private void mnuEnableProgress_Click(object sender, EventArgs e)
        {
            mnuEnableProgress.Checked = !mnuEnableProgress.Checked;
        }

        #endregion

        #region Save Dialog
        private void mnuSave_Click(object sender, EventArgs e)
        {
            int iQuality;
            frmConfigJpeg fConfigJpeg = new frmConfigJpeg();
            if (fConfigJpeg.ShowDialog() == DialogResult.OK)
            {
                iQuality = fConfigJpeg.trackBar1.Value;

                dlgSave.FileName = FileName;
                dlgSave.Filter = "Jpeg File(*.JPEG;*.JPG)|*.JPEG;*.JPG";
                dlgSave.DefaultExt = "*.jpg";
                if (dlgSave.ShowDialog() == DialogResult.OK)
                {
                    Controller pc = new Controller(pic.Image);
                    string SaveFileName = dlgSave.FileName;
                    pc.Save(SaveFileName, CompressionType.CompressionNone, iQuality, PhotoFormat.Jpeg);
                    pc.Dispose();
                }
            }
        }

        private void mnuSaveGif_Click(object sender, EventArgs e)
        {
            int iQuality;
            frmSaveGif fSaveGif = new frmSaveGif();
            if (fSaveGif.ShowDialog() == DialogResult.OK)
            {
                iQuality = fSaveGif.barColor.Value;
                bool transparent = fSaveGif.chkTransparent.Checked;
                CompressionType ct = CompressionType.GifStandard256;
                Color transColor = fSaveGif.btColor.BackColor;

                if (fSaveGif.comboBox1.SelectedIndex == 0)
                    ct = CompressionType.GifAdaptive;
                else if (fSaveGif.comboBox1.SelectedIndex == 1)
                    ct = CompressionType.GifOctreeQuantizer;
                else if (fSaveGif.comboBox1.SelectedIndex == 2)
                    ct = CompressionType.GifStandard256;
                else if (fSaveGif.comboBox1.SelectedIndex == 3)
                    ct = CompressionType.GifWebSafe;

                dlgSave.FileName = FileName;
                dlgSave.Filter = "Gif File(*.GIF)|*.gif";
                dlgSave.DefaultExt = "*.gif";
                if (dlgSave.ShowDialog() == DialogResult.OK)
                {
                    Controller pc = new Controller(pic.Image);
                    string SaveFileName = dlgSave.FileName;
                    pc.Save(SaveFileName, ct, iQuality, PhotoFormat.Gif, transparent, transColor);

                    pc.Dispose();
                }
            }
        }
        #endregion

        #region Draw a rectangle on the picture, it's a very dirty way and not very beautiful (no Marching Ants)

        // It's updated on 2006. Oct. 29th

        // this part is very simple, just draw an ugly rectangle on the picture
        // to remove the selection, just click anywhere once, the selection will not be removed, but the ptBeg and ptEnd
        // will be reset. 

        // return a rectangle according to start point and end point
        private Rectangle Rect(Point begPoint, Point endPoint)
        {
            return new Rectangle(begPoint.X, begPoint.Y, (endPoint.X - begPoint.X), (endPoint.Y - begPoint.Y));
        }

        private void DrawSelection()
        {
            Graphics gx = pic.CreateGraphics();
            HatchBrush hb = new HatchBrush(HatchStyle.Weave, Color.Black, Color.White);
            Pen pen = new Pen(hb, 1);
            gx.DrawRectangle(pen, Rect(ptBeg, ptEnd));
            gx.Dispose();
        }

        private void ShowSelection()
        {
            if (ptBeg == ptEnd)
                this.statusPalAddon.Text = "";
            else
                this.statusPalAddon.Text = "CropX1=" + ptBeg.X.ToString() + ";"
                                    + "CropY1=" + ptBeg.Y.ToString() + ";"
                                    + "CropX2=" + ptEnd.X.ToString() + ";"
                                    + "CropY2=" + ptEnd.Y.ToString();
        }

        private void pic_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                ptBeg = ptEnd = new Point(e.X, e.Y);
                bBlocking = true;
                DrawSelection();
                ShowSelection();
            }
        }

        private void pic_MouseMove(object sender, MouseEventArgs e)
        {
            if (bBlocking && (e.Button & MouseButtons.Left) != 0)
            {

                DrawSelection();

                pic.Invalidate();
                ptEnd = new Point(e.X, e.Y);

                DrawSelection();


                ShowSelection();
            }
        }

        private void pic_MouseUp(object sender, MouseEventArgs e)
        {
            if (bBlocking)
            {
                bBlocking = false;
                DrawSelection();

                if (ptBeg == ptEnd)
                {
                    ptBeg = new Point(0, 0);
                    ptEnd = new Point(0, 0);
                    DrawSelection();
                }
                Invalidate();
                ShowSelection();
            }
        }

        private void pic_Paint(object sender, PaintEventArgs e)
        {
            if (pic.Image != null)
                this.statusPalCurrent.Text = "Current Image:" + pic.Image.Width.ToString() + "X" + pic.Image.Height.ToString() + "X" + pic.Image.PixelFormat.ToString();
        }

        #endregion

        #region Basic Operations, including resize, crop, rotate, flip, crop, etc.
        private void mnuResize_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;

            // creates the ResizeForm
            frmResize fResize = new frmResize();

            // initialize the ResizeForm component values
            fResize.txtHeight.Value = pic.Image.Height;
            fResize.txtWidth.Value = pic.Image.Width;

            // if user click OK button, then resize
            if (fResize.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);

                // new feature in 1.2 
                pc.InterpolationMode = (InterpolationMode)fResize.cboxIMode.SelectedIndex;

                pic.Image = pc.Resize(fResize.NewWidth, fResize.NewHeight);
                pc.Dispose();
                setRefresh(true);
            }
        }

        // Modified in V2.0
        private void menuScale_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;
            frmScale fScale = new frmScale();
            if (fScale.ShowDialog() == DialogResult.OK)
            {
                int width;
                int height;
                try
                {
                    width = int.Parse(fScale.txtWidth.Text);
                    height = int.Parse(fScale.txtHeight.Text);
                }
                catch
                {
                    Helper.ShowError("You must enter integer for width and height!");
                    return;
                }
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.Scale(width, height);
                pc.Dispose();
                setRefresh(true);
            }

        }

        private void mnuRotate_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;
            frmRotate fRotate = new frmRotate();
            fRotate.MyParentForm = this;
            if (fRotate.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.Rotate((float)Convert.ToDouble(fRotate.txtAngle.Text), Color.FromName(fRotate.cboxBackColor.Text));
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuFlip_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;
            frmFlip fFlip = new frmFlip();
            fFlip.myParentForm = this;
            if (fFlip.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.Flip(fFlip.flipflag);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuCrop_Click(object sender, EventArgs e)
        {
            if (ptBeg.X == 0 && ptBeg.Y == 0 && ptEnd.X == 0 && ptEnd.Y == 0)
            {
                Helper.ShowError("Please select a region on the image firstly!");
            }
            else if (FileName != "" && pic.Image != null)
            {
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.Crop(ptBeg, ptEnd);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuAdjust_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;
            if (dlgColor.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.ColorAdjust(dlgColor.Color);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuTransparent_Click(object sender, EventArgs e)
        {
            if (FileName == "" || pic.Image == null) return;
            frmOpacity fOpacity = new frmOpacity();
            fOpacity.MyParentForm = this;
            if (fOpacity.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                pic.Image = pc.Transparent((sbyte)fOpacity.trackOpacity.Value);
                pc.Dispose();
                setRefresh(true);
            }
        }

        #endregion

        #region Filter Helper function - configurate BaseFilter object
        /// <summary>
        /// Configs the filter.
        /// </summary>
        /// <param name="filter">The filter.</param>
        private void ConfigFilter(BaseFilter filter)
        {
            filter.DrawArea = new Rectangle(ptBeg.X, ptBeg.Y, ptEnd.X - ptBeg.X, ptEnd.Y - ptBeg.Y);

            if (mnuEnableProgress.Checked)
            {
                filter.PercentageChanged += new PercentageHandler(filter_PercentageChanged);
            }
        }

        /// <summary>
        /// this event is triggered when the processing percentage changed.
        /// </summary>
        /// <param name="percentage">The percentage.</param>
        private void filter_PercentageChanged(int percentage)
        {
            if (percentage != barProgress.Value)
                barProgress.Value = percentage;
        }

        #endregion

        #region Feather functions
        //below are feather related functions
        //FEATHER function is very powerful, so I can't show all of them in here.
        //I will consider to write a forum online to let all users to discuss it


        // This is the easiest way to feather the image with selected rectangle
        // In fact, I am too lazy to write code to draw other shapes on the picture,
        // Feather fucntion can work with kinds of shape.
        // If you write the code to draw any shape on the picture, could you 
        // mail to me so that I could integrate into this program
        //
        // 1. select a background for feather
        // 2. create a featherbuilder object, assign the background color (default is black)
        // 3. build a rectangle mask, this function will use the rectangle size that is drawn on the image
        // 4. call feather function
        private void mnuFeather1_Click(object sender, EventArgs e)
        {
            if (dlgColor.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                FeatherBuilder builder = new FeatherBuilder(pic.Image.Width, pic.Image.Height);
                builder.BackgroundColor = dlgColor.Color;
                builder.BuildRectangleMask(Rect(ptBeg, ptEnd));
                pic.Image = pc.Feather(builder);
                pc.Dispose();
                builder.Dispose();
                setRefresh(true);
            }
        }

        // This function demostrate how to frame in a feather way
        // PhotoController could specify a tile bitmap as background
        // after feathering, the specialized tile bitmap will replace other places except the selected region
        //
        // I specify 25 as a frame width, change that value if you like
        //
        // This 
        private void mnuFeather2_Click(object sender, EventArgs e)
        {
            Controller pc = new Controller(pic.Image);
            FeatherBuilder builder = new FeatherBuilder(pic.Image.Width, pic.Image.Height);

            // tell builder to use bitmap as background
            builder.BackgroundStyle = FeatherBackgroundStyle.UseBitmap;

            string currentfolder = Path.GetDirectoryName(Application.ExecutablePath);
            builder.LoadTileBitmap(currentfolder + "\\BackgroundTexture1.bmp");

            // IMPORATNT
            // set band to be a small value.
            // if you set this too large, the picture will be feathered too much
            builder.Band = 2;

            // create a rectangle that is 25 smaller than picture
            // the width 25 will be replaced by tile bitmap
            Rectangle rect = new Rectangle(25, 25, pic.Image.Width - 50, pic.Image.Height - 50);
            builder.BuildRectangleMask(rect);

            // this border style might not be similar to a frame shadow, you could try others
            BorderBuilder borderBuilder = new BorderBuilder();
            borderBuilder.Brush = new SolidBrush(Color.Gray);
            borderBuilder.Length = 27;

            // because the feather background will occupy 25 width, the border width here must be larger than 25 so that
            // it could be seen and have a frame feeling
            // write border firstly to have a shadow feeling
            pc.SetBorder(borderBuilder);

            // after writing a border, then feather myself to have a similar frame feeling
            pic.Image = pc.Feather(builder);
            pc.Dispose();
            builder.Dispose();
            setRefresh(true);
        }

        // This function demostrates how to feather in different shapes
        // to have a best effect, I recommend to use a large image
        // because the mask size is hardcode here.

        private void mnuFeather3_Click(object sender, EventArgs e)
        {
            if (pic.Image == null)
            {
                MessageBox.Show("Please load an image firstly.");
                return;
            }

            if (pic.Image.Width < 300 && pic.Image.Height < 300)
            {
                MessageBox.Show("Please load a large size picture to get a best effect.");
                return;
            }

            frmFeather fFeather = new frmFeather();
            if (fFeather.ShowDialog() == DialogResult.OK)
            {
                int band = fFeather.trackBand.Value;
                Color backgroundcolor = fFeather.btColor.BackColor;
                int width = pic.Image.Width;
                int height = pic.Image.Height;

                //initialize PhotoController and FeatherBuilder
                Controller pc = new Controller(pic.Image);
                FeatherBuilder builder = new FeatherBuilder(width, height);

                //default background color is black
                //you must set this value if you want to specify it
                builder.BackgroundColor = backgroundcolor;

                //default feather band is 16
                //you must set this value is you want to specify it
                builder.Band = band;

                switch (fFeather.cboxStyle.SelectedIndex)
                {
                    case 0: // create an ellipse mask
                        {
                            Rectangle rect = new Rectangle(band + 20, band + 20, width - (band + 20) * 2, height - (band + 20) * 2);
                            builder.BuildEllipseMask(rect);
                            break;
                        }
                    case 1: // create a mask like a door with graphicpah
                        {
                            GraphicsPath path = new GraphicsPath();
                            path.AddEllipse(50, 50, width - 50 - band * 2, 200);
                            path.AddRectangle(new Rectangle(50, 150, width - 50 - band * 2, height - 150 - band * 2));
                            builder.BuildPathMask(path);
                            break;
                        }
                    case 2: // create rectangles mask
                        {
                            RectangleF[] rects ={
												new RectangleF(  50.0F,   50.0F, width - 100, 200.0F),
												new RectangleF(100.0F, 200.0F, 250.0F,  150.0F),
												new RectangleF(200.0F, 250.0F, 180.0F, height - 300.0f)
											};
                            builder.BuildRectanglesMask(rects);
                            break;
                        }
                    case 3: // create a casual closed curve
                        {
                            PointF point1 = new PointF(width / 2, 50 + band * 2);
                            PointF point2 = new PointF(width * 3 / 4, height / 4);
                            PointF point3 = new PointF(width * 7 / 8, height / 2);
                            PointF point4 = new PointF(width * 3 / 4, height - 100 - band * 2);
                            PointF point5 = new PointF(width / 4, height - 100 - band * 2);
                            PointF point6 = new PointF(width / 8, height / 2);

                            PointF[] points = { point1, point2, point3, point4, point5, point6 };

                            //the second parameter is FillMode
                            //the third parameter is tension, do not set too large, otherwise the shape will be very strange
                            //you could find this parameter's meaning in MSDN
                            builder.BuildClosedCurveMask(points, FillMode.Winding, 1.0f);
                            break;
                        }
                    case 4: // create a casual polygon
                        {
                            PointF point1 = new PointF(width / 2, 50 + band * 2);
                            PointF point2 = new PointF(width * 3 / 4, height / 4);
                            PointF point3 = new PointF(width * 7 / 8, height / 2);
                            PointF point4 = new PointF(width * 3 / 4, height - 100 - band * 2);
                            PointF point5 = new PointF(width / 4, height - 100 - band * 2);
                            PointF point6 = new PointF(width / 8, height / 2);

                            PointF[] points = { point1, point2, point3, point4, point5, point6 };

                            builder.BuildPolygonMask(points);
                            break;
                        }
                }

                pic.Image = pc.Feather(builder);
                pc.Dispose();
                builder.Dispose();
                setRefresh(true);
            }
        }

        #endregion

        #region Image border methods
        private void mnuSetBorder_Click(object sender, EventArgs e)
        {
            frmBorder fBorder = new frmBorder();
            if (fBorder.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                BorderBuilder builder = fBorder.BorderBuilder;
                pic.Image = pc.SetBorder(builder);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuGradientBorder_Click(object sender, EventArgs e)
        {
            frmGradientBorder fBorder = new frmGradientBorder();
            if (fBorder.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                BorderBuilder builder = fBorder.BorderBuilder;
                pic.Image = pc.SetBorder(builder);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuTextureBorder_Click(object sender, EventArgs e)
        {
            frmTextureBorder fBorder = new frmTextureBorder();
            if (fBorder.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                BorderBuilder builder = fBorder.BorderBuilder;
                pic.Image = pc.SetBorder(builder);
                pc.Dispose();
                setRefresh(true);
            }
        }
        #endregion

        #region Filters
        private void mnuInvert_Click(object sender, EventArgs e)
        {
            Controller pc = new Controller(pic.Image);
            InvertColorFilter filter = new InvertColorFilter();
            ConfigFilter(filter);
            pic.Image = pc.Filter(filter);
            pc.Dispose();
            setRefresh(true);
        }

        private void mnuGray_Click(object sender, EventArgs e)
        {
            Controller pc = new Controller(pic.Image);
            GrayScaleFilter filter = new GrayScaleFilter();
            ConfigFilter(filter);
            pic.Image = pc.Filter(filter);
            pc.Dispose();
            setRefresh(true);
        }

        private void mnuGrey_Click(object sender, EventArgs e)
        {
            Controller pc = new Controller(pic.Image);
            GreyColorFilter filter = new GreyColorFilter();
            ConfigFilter(filter);
            pic.Image = pc.Filter(filter);
            pc.Dispose();
            setRefresh(true);
        }

        private void mnuBlackWhite_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 255;
            fParam.trackLevel.Value = 128; fParam.trackLevel.TickFrequency = 20;
            fParam.Text = "BlackWhite Threshold";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                BlackWhiteFilter filter = new BlackWhiteFilter();
                filter.Threshold = fParam.trackLevel.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        /// <summary>
        /// New sepia
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mnuSepia_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            fParam.Text = "Contrast Adjust";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                SepiaFilter filter = new SepiaFilter();
                ConfigFilter(filter);
                filter.Level = fParam.trackLevel.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        /// <summary>
        /// new contrast
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mnuContrast_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.trackLevel.Minimum = -100; fParam.trackLevel.Maximum = 100;
            fParam.Text = "Contrast Adjust";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                ContrastFilter filter = new ContrastFilter();
                ConfigFilter(filter);
                filter.Level = fParam.trackLevel.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuGamma_Click(object sender, EventArgs e)
        {
            // New in V2.0, the original method SetGamma is deprecated
            // the new way is recommended

            frmGamma fGamma = new frmGamma();
            if (fGamma.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                GammaAdjustFilter filter = new GammaAdjustFilter();
                filter.RedGamma = (double)fGamma.trackRed.Value / 10;
                filter.GreenGamma = (double)fGamma.trackGreen.Value / 10;
                filter.BlueGamma = (double)fGamma.trackBlue.Value / 10;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        // New method
        private void mnuHSL_Click(object sender, EventArgs e)
        {
            frmHSL fHSL = new frmHSL();
            if (fHSL.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                HSLAdjustFilter filter = new HSLAdjustFilter();
                filter.Hue = fHSL.trackH.Value;
                filter.Saturation = fHSL.trackS.Value / 100.0f;
                filter.Lightness = fHSL.trackL.Value / 100.0f;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuSmooth_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Smooth Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                //IC.PhotoController.Filters filters=new Filters(FilterStyle.Smooth);
                //filters.Level = fParam.trackLevel.Value;
                SmoothFilter filter = new SmoothFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuBlur_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "GaussianBlur Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                GaussianBlurFilter filter = new GaussianBlurFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuSharpen_Click(object sender, EventArgs e)
        {
            //Sharpen need a level between 0 and 10
            frmParam fParam = new frmParam();
            fParam.Text = "Sharpen Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 10;
            fParam.trackLevel.TickFrequency = 1;
            fParam.trackLevel.LargeChange = 1;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                SharpenFilter filter = new SharpenFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuMeanRemoval_Click(object sender, EventArgs e)
        {
            //MeanRemval need a level between 0 and 10
            frmParam fParam = new frmParam();
            fParam.Text = "MeanRemoval Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 10;
            fParam.trackLevel.TickFrequency = 1;
            fParam.trackLevel.LargeChange = 1;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                MeanRemovalFilter filter = new MeanRemovalFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEmboss_Click(object sender, EventArgs e)
        {
            frmEmboss fParam = new frmEmboss();
            fParam.Text = "Emboss Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EmbossFilter filter = new EmbossFilter();
                filter.Level = fParam.trackLevel.Value;
                filter.Direction = fParam.trackDirection.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEngrave_Click(object sender, EventArgs e)
        {
            //engrave doesn't need a level value
            Controller pc = new Controller(pic.Image);

            // you can simply call this method to apply the convolution
            //pic.Image = pc.Filter(IC.PhotoController.FilterStyle.Engrave);

            // but if you want to specify the filter region, you will  have to create a filter object
            EngraveFilter filter = new EngraveFilter();
            ConfigFilter(filter);
            pic.Image = pc.Filter(filter);

            pc.Dispose();
            setRefresh(true);
        }

        private void mnuEDSobel_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect Sobel Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectSobelFilter filter = new EdgeDetectSobelFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEDPrewiit_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect Prewitt Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectPrewittFilter filter = new EdgeDetectPrewittFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEDKirsh_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect Kirsh Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectKirshFilter filter = new EdgeDetectKirshFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void EdgeDetectFreiChen_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect FreiChen Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectFreiChenFilter filter = new EdgeDetectFreiChenFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEDRoberts_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect Roberts Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectRobertsFilter filter = new EdgeDetectRobertsFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuEDDifference_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "EdgeDetect Difference Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                EdgeDetectDifferenceFilter filter = new EdgeDetectDifferenceFilter();
                filter.Threshold = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuMosaicNormal_Click(object sender, EventArgs e)
        {
            frmMosaic fParam = new frmMosaic();
            fParam.Text = "Mosaic Parameters";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                MosaicFilter filter = new MosaicFilter();
                filter.Level = fParam.trackLevel.Value;
                filter.Grid = fParam.chkMosaic.Checked;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuDiffuse_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Diffuse Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                DiffuseFilter filter = new DiffuseFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuDither_Click(object sender, EventArgs e)
        {
            frmDither fParam = new frmDither();
            fParam.Text = "Dither Parameters";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                DitherFilter filter = new DitherFilter();
                filter.Level = fParam.trackLevel.Value;
                filter.Horizontal = fParam.chkHorizontal.Checked;
                filter.Vertical = fParam.chkVertical.Checked;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuCanvas_Click(object sender, EventArgs e)
        {
            frmCanvas fCanvas = new frmCanvas();
            fCanvas.lbeHeight.Text = fCanvas.txtHeight.Text = pic.Image.Height.ToString();
            fCanvas.lbeWidth.Text = fCanvas.txtWidth.Text = pic.Image.Width.ToString();
            if (fCanvas.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                AnchorType anchor = (AnchorType)fCanvas.cboxAnchor.SelectedIndex;
                pic.Image = pc.CanvasSize(int.Parse(fCanvas.txtWidth.Text), int.Parse(fCanvas.txtHeight.Text), anchor, Color.White);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuGlassBorder_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "GlassVessel Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 255;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                GlassBorderFilter filter = new GlassBorderFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuWater_Click(object sender, EventArgs e)
        {
            frmWater fParam = new frmWater();
            fParam.Text = "Water Parameters";

            // The following code demonstrates how to read parameter configurations
            WaterFilter filter = new WaterFilter();
            using (ParamConfig config = new ParamConfig())
            {
                string max, min, defaultValue, type;

                // get the definition of filter.Level
                if (config.FindParam(filter.ToString(), "Level", out type, out max, out min, out defaultValue))
                {
                    fParam.trackLevel.Maximum = int.Parse(max);
                    fParam.trackLevel.Minimum = int.Parse(min);
                    fParam.trackLevel.Value = int.Parse(defaultValue);
                }

                if (config.FindParam(filter.ToString(), "Wave", out type, out max, out min, out defaultValue))
                {
                    fParam.trackWave.Maximum = int.Parse(max);
                    fParam.trackWave.Minimum = int.Parse(min);
                    fParam.trackWave.Value = int.Parse(defaultValue);
                }
            }

            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);

                filter.Level = fParam.trackLevel.Value;
                filter.Wave = fParam.trackWave.Value;
                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        // New in 2.0
        private void mnuWaterRipple_Click(object sender, EventArgs e)
        {
            frmWaterRipple fParam = new frmWaterRipple();
            fParam.Text = "Water Ripple Parameters";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                WaterRippleFilter filter = new WaterRippleFilter();
                filter.Level = fParam.trackLevel.Value;
                filter.Wave = fParam.trackWave.Value;
                filter.CenterX = fParam.trackCenterX.Value;
                filter.CenterY = fParam.trackCenterY.Value;
                filter.Angle = fParam.trackAngle.Value;
                filter.Amplitude = fParam.trackAmplitude.Value;
                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuTwirl_Click(object sender, EventArgs e)
        {
            frmTwirl fParam = new frmTwirl();
            fParam.Text = "Twirl Parameters Level";
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                TwirlFilter filter = new TwirlFilter();
                filter.Angle = fParam.trackAngle.Value;
                filter.CenterX = fParam.trackCenterX.Value;
                filter.CenterY = fParam.trackCenterY.Value;
                filter.Radius = fParam.trackLevel.Value;
                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuSolarize_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Solarization Level";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 255;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                SolarizeFilter filter = new SolarizeFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        #region New Features in 1.2
        private void mnuDirtyBlur_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Deep Blur";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                //IC.PhotoController.Filters filters=new Filters(FilterStyle.DeepBlur);
                DeepBlurFilter filter = new DeepBlurFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuNoise_Click(object sender, EventArgs e)
        {
            // borrow the mosaic form, since the properties are similar
            frmMosaic fParam = new frmMosaic();
            fParam.Text = "Noise Parameters";
            fParam.chkMosaic.Text = "Color Noise";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 100;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                NoiseFilter filter = new NoiseFilter();
                filter.Level = fParam.trackLevel.Value;
                filter.ColorNoise = fParam.chkMosaic.Checked;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuDarkness_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Darkness";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 200;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                DarknessFilter filter = new DarknessFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuLightness_Click(object sender, EventArgs e)
        {
            frmParam fParam = new frmParam();
            fParam.Text = "Lightness";
            fParam.trackLevel.Minimum = 0; fParam.trackLevel.Maximum = 200;
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                LightnessFilter filter = new LightnessFilter();
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }
        #endregion

        #region New Filters after v2.0
        private void mnuShear_Click(object sender, EventArgs e)
        {
            frmShear fParam = new frmShear();
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                ShearFilter filter = new ShearFilter();
                filter.HorizontalAngle = fParam.trackCenterX.Value;
                filter.VerticalAngle = fParam.trackCenterY.Value;
                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }

        }

        private void mnuSphere_Click(object sender, EventArgs e)
        {
            frmSphere fParam = new frmSphere();
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                SphereFilter filter = new SphereFilter();
                filter.CenterX = fParam.trackCenterX.Value;
                filter.CenterY = fParam.trackCenterY.Value;
                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                filter.Zoom = fParam.trackProtrusion.Value;
                filter.Radius = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuMarble_Click(object sender, EventArgs e)
        {
            frmMarble fParam = new frmMarble();
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                MarbleFilter filter = new MarbleFilter();

                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                filter.Level = fParam.trackLevel.Value;
                filter.Turbulence = fParam.trackTurbulence.Value;
                filter.Movement = fParam.trackMovement.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }

        }

        private void mnuShake_Click(object sender, EventArgs e)
        {
            frmShake fParam = new frmShake();
            if (fParam.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                ShakeFilter filter = new ShakeFilter();

                filter.Edge = (EdgeType)fParam.comboBox1.SelectedIndex;
                filter.Level = fParam.trackLevel.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuCustomerFilter_Click(object sender, EventArgs e)
        {
            // this method is calling the customer filter, no parameter is needed

            // FastEdgeDetectFilter filter = new FastEdgeDetectFilter();
            // MirrorFilter filter = new MirrorFilter();
            PosterizeFilter filter = new PosterizeFilter();
            filter.Level = 5;

            Controller pc = new Controller(pic.Image);

            pic.Image = pc.Filter(filter);
            pc.Dispose();
            setRefresh(true);
        }
        #endregion

        /*********************************************************************/
        // new operations added after 2006/09
        /*********************************************************************/
        #region New Filters in v2.1
        private void mnuAutoColorEnhance_Click(object sender, EventArgs e)
        {
            AutoColorEnhanceFilter filter = new AutoColorEnhanceFilter();
            Controller pc = new Controller(pic.Image);
            ConfigFilter(filter);
            pic.Image = pc.Filter(filter);
            pc.Dispose();
            setRefresh(true);
        }

        private void mnuBomb_Click(object sender, EventArgs e)
        {
            frmBomb frm = new frmBomb();
            frm.parent = this;
            if (frm.ShowDialog() == DialogResult.OK)
            {
                BombWaveFilter filter = new BombWaveFilter();
                filter.Amplitude = frm.tbAmplitude.Value;
                filter.Centre = new PointF(frm.tbCentreX.Value, frm.tbCentreY.Value);
                filter.Radius = frm.tbRadius.Value;
                filter.WaveLength = frm.tbWaveLength.Value;
                filter.Edge = (EdgeType)frm.comboBox1.SelectedIndex;

                Controller pc = new Controller(pic.Image);
                pic.Image.Dispose();
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuSpreadNoise_Click(object sender, EventArgs e)
        {
            frmSpreadNoise frm = new frmSpreadNoise();
            if (frm.ShowDialog() == DialogResult.OK)
            {
                SpreadFilter filter = new SpreadFilter();
                filter.HorizontalDistance = frm.tbHorizontal.Value;
                filter.VerticalDistance = frm.tbVertical.Value;
                filter.Edge = (EdgeType)frm.comboBox1.SelectedIndex;

                Controller pc = new Controller(pic.Image);
                pic.Image.Dispose();
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuOil_Click(object sender, EventArgs e)
        {
            frmOil dlg = new frmOil();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                OilFilter filter = new OilFilter();
                ConfigFilter(filter);
                filter.Coarse = (byte)dlg.trackCoarseness.Value;
                filter.BrushSize = dlg.trackBrushSize.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuWind_Click(object sender, EventArgs e)
        {
            frmWind dlg = new frmWind();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                WindFilter filter = new WindFilter();
                filter.Edge = (WindFilter.EdgeMode)dlg.cboxEdgeMode.SelectedIndex;
                filter.Style = (WindFilter.BlowStyle)dlg.cboxBlowStyle.SelectedIndex;
                filter.Strength = dlg.trackStrength.Value;
                filter.Threshold = dlg.trackThreshold.Value;
                ConfigFilter(filter);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuRedEyeRemoval_Click(object sender, EventArgs e)
        {
            frmParam dlg = new frmParam();
            dlg.trackLevel.Minimum = 1; dlg.trackLevel.Maximum = 100;
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                RedEyeFilter filter = new RedEyeFilter();
                ConfigFilter(filter);
                filter.Threshold = dlg.trackLevel.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        private void mnuLinearBlur_Click(object sender, EventArgs e)
        {
            frmLinearBlur dlg = new frmLinearBlur();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                LinearBlurFilter filter = new LinearBlurFilter();
                ConfigFilter(filter);
                filter.Angle = dlg.trackAngle.Value;
                filter.Length = (int)dlg.numLength.Value;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

        #endregion

        private void mnuRadialBlur_Click(object sender, EventArgs e)
        {
            frmRadialBlur dlg = new frmRadialBlur();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                RadialBlurFilter filter = new RadialBlurFilter();
                ConfigFilter(filter);
                filter.Angle = dlg.trackAngle.Value;
                filter.Centre = new Point(dlg.trackCentreX.Value, dlg.trackCentreY.Value);
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }


        #endregion

        private void mnuZoomBlur_Click(object sender, EventArgs e)
        {
            frmZoomBlurFilter dlg = new frmZoomBlurFilter();
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                Controller pc = new Controller(pic.Image);
                ZoomBlurFilter filter = new ZoomBlurFilter();
                ConfigFilter(filter);
                filter.Level = dlg.trackLevel.Value;
                filter.Centre = new Point(dlg.trackCentreX.Value, dlg.trackCentreY.Value);
                filter.Outward = dlg.chkOutward.Checked;
                pic.Image = pc.Filter(filter);
                pc.Dispose();
                setRefresh(true);
            }
        }

    }
}
