using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using IC.PhotoController;
using IC.PhotoController.Filter;

namespace PhotoControllerWebDemo
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public partial class WebForm1 : System.Web.UI.Page
	{
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		protected void rbColor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (Page.IsPostBack) 
			{
				Response.ContentType = "image/jpeg";

				IC.PhotoController.Controller objpc = new Controller();
				System.Drawing.Image img = System.Drawing.Image.FromFile(Server.MapPath("..") + "\\PhotoControllerWebDemo\\" + this.image.ImageUrl);
				objpc.LoadImage(img);
			
				switch (rbColor.SelectedIndex)
				{
					case 0: 
					{
                        //in V2.0, I can either create a filter object 
                        img = objpc.Filter(new GrayScaleFilter());
						break;
					}
					case 1:
					{
                        // or just pass the filterstyle to let photocontroller to create the object for me
                        img = objpc.Filter(FilterStyle.Grey);

                        // in this case, since GreyColorFilter() doesn'have any property
                        // using FilterStyle is more convenient than create a filter object
						break;
					}
					case 2:
					{
                        img = objpc.Filter(FilterStyle.Invert);
						break;
					}
					case 3:
					{
                        SepiaFilter filter = new SepiaFilter();
                        filter.Level = 21;
                        img = objpc.Filter(filter);
						break;
					}
					case 4: 
					{
						img = objpc.Flip(FlipFlags.FlipHorizontal);
						break;
					}
					case 5:
					{
						img = objpc.Flip(FlipFlags.FlipVertical);
						break;
					}
					case 6:
					{
						img = objpc.Flip(FlipFlags.FlipBoth);
						break;
					}
                case 7:
                    {
                        EmbossFilter filter = new EmbossFilter();
                        filter.Level = 3;
                        filter.Direction = 120;
                        img = objpc.Filter(filter);
                        break;
                    }

				}

				Bitmap b = new Bitmap(img);
				System.IO.MemoryStream oStream=new System.IO.MemoryStream();
				Response.ClearContent();
				b.Save(oStream,System.Drawing.Imaging.ImageFormat.Jpeg);
				Response.BinaryWrite(oStream.ToArray());
				objpc.Dispose();
				img.Dispose();
				b.Dispose();
				Response.End();
			}
		}

	}
}
